// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rtabmap_ros:msg/EnvSensor.idl
// generated code does not contain a copyright notice

#ifndef RTABMAP_ROS__MSG__DETAIL__ENV_SENSOR__TRAITS_HPP_
#define RTABMAP_ROS__MSG__DETAIL__ENV_SENSOR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rtabmap_ros/msg/detail/env_sensor__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rtabmap_ros
{

namespace msg
{

inline void to_flow_style_yaml(
  const EnvSensor & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: value
  {
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EnvSensor & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EnvSensor & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rtabmap_ros

namespace rosidl_generator_traits
{

[[deprecated("use rtabmap_ros::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rtabmap_ros::msg::EnvSensor & msg,
  std::ostream & out, size_t indentation = 0)
{
  rtabmap_ros::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rtabmap_ros::msg::to_yaml() instead")]]
inline std::string to_yaml(const rtabmap_ros::msg::EnvSensor & msg)
{
  return rtabmap_ros::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rtabmap_ros::msg::EnvSensor>()
{
  return "rtabmap_ros::msg::EnvSensor";
}

template<>
inline const char * name<rtabmap_ros::msg::EnvSensor>()
{
  return "rtabmap_ros/msg/EnvSensor";
}

template<>
struct has_fixed_size<rtabmap_ros::msg::EnvSensor>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<rtabmap_ros::msg::EnvSensor>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<rtabmap_ros::msg::EnvSensor>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RTABMAP_ROS__MSG__DETAIL__ENV_SENSOR__TRAITS_HPP_
