// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rtabmap_ros:msg/NodeData.idl
// generated code does not contain a copyright notice

#ifndef RTABMAP_ROS__MSG__DETAIL__NODE_DATA__TRAITS_HPP_
#define RTABMAP_ROS__MSG__DETAIL__NODE_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rtabmap_ros/msg/detail/node_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
// Member 'ground_truth_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'gps'
#include "rtabmap_ros/msg/detail/gps__traits.hpp"
// Member 'local_transform'
// Member 'laser_scan_local_transform'
#include "geometry_msgs/msg/detail/transform__traits.hpp"
// Member 'grid_view_point'
// Member 'word_pts'
#include "rtabmap_ros/msg/detail/point3f__traits.hpp"
// Member 'word_kpts'
#include "rtabmap_ros/msg/detail/key_point__traits.hpp"
// Member 'global_descriptors'
#include "rtabmap_ros/msg/detail/global_descriptor__traits.hpp"
// Member 'env_sensors'
#include "rtabmap_ros/msg/detail/env_sensor__traits.hpp"

namespace rtabmap_ros
{

namespace msg
{

inline void to_flow_style_yaml(
  const NodeData & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: map_id
  {
    out << "map_id: ";
    rosidl_generator_traits::value_to_yaml(msg.map_id, out);
    out << ", ";
  }

  // member: weight
  {
    out << "weight: ";
    rosidl_generator_traits::value_to_yaml(msg.weight, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    rosidl_generator_traits::value_to_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: label
  {
    out << "label: ";
    rosidl_generator_traits::value_to_yaml(msg.label, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: ground_truth_pose
  {
    out << "ground_truth_pose: ";
    to_flow_style_yaml(msg.ground_truth_pose, out);
    out << ", ";
  }

  // member: gps
  {
    out << "gps: ";
    to_flow_style_yaml(msg.gps, out);
    out << ", ";
  }

  // member: image
  {
    if (msg.image.size() == 0) {
      out << "image: []";
    } else {
      out << "image: [";
      size_t pending_items = msg.image.size();
      for (auto item : msg.image) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: depth
  {
    if (msg.depth.size() == 0) {
      out << "depth: []";
    } else {
      out << "depth: [";
      size_t pending_items = msg.depth.size();
      for (auto item : msg.depth) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: fx
  {
    if (msg.fx.size() == 0) {
      out << "fx: []";
    } else {
      out << "fx: [";
      size_t pending_items = msg.fx.size();
      for (auto item : msg.fx) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: fy
  {
    if (msg.fy.size() == 0) {
      out << "fy: []";
    } else {
      out << "fy: [";
      size_t pending_items = msg.fy.size();
      for (auto item : msg.fy) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: cx
  {
    if (msg.cx.size() == 0) {
      out << "cx: []";
    } else {
      out << "cx: [";
      size_t pending_items = msg.cx.size();
      for (auto item : msg.cx) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: cy
  {
    if (msg.cy.size() == 0) {
      out << "cy: []";
    } else {
      out << "cy: [";
      size_t pending_items = msg.cy.size();
      for (auto item : msg.cy) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: width
  {
    if (msg.width.size() == 0) {
      out << "width: []";
    } else {
      out << "width: [";
      size_t pending_items = msg.width.size();
      for (auto item : msg.width) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: height
  {
    if (msg.height.size() == 0) {
      out << "height: []";
    } else {
      out << "height: [";
      size_t pending_items = msg.height.size();
      for (auto item : msg.height) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: baseline
  {
    if (msg.baseline.size() == 0) {
      out << "baseline: []";
    } else {
      out << "baseline: [";
      size_t pending_items = msg.baseline.size();
      for (auto item : msg.baseline) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: local_transform
  {
    if (msg.local_transform.size() == 0) {
      out << "local_transform: []";
    } else {
      out << "local_transform: [";
      size_t pending_items = msg.local_transform.size();
      for (auto item : msg.local_transform) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: laser_scan
  {
    if (msg.laser_scan.size() == 0) {
      out << "laser_scan: []";
    } else {
      out << "laser_scan: [";
      size_t pending_items = msg.laser_scan.size();
      for (auto item : msg.laser_scan) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: laser_scan_max_pts
  {
    out << "laser_scan_max_pts: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_scan_max_pts, out);
    out << ", ";
  }

  // member: laser_scan_max_range
  {
    out << "laser_scan_max_range: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_scan_max_range, out);
    out << ", ";
  }

  // member: laser_scan_format
  {
    out << "laser_scan_format: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_scan_format, out);
    out << ", ";
  }

  // member: laser_scan_local_transform
  {
    out << "laser_scan_local_transform: ";
    to_flow_style_yaml(msg.laser_scan_local_transform, out);
    out << ", ";
  }

  // member: user_data
  {
    if (msg.user_data.size() == 0) {
      out << "user_data: []";
    } else {
      out << "user_data: [";
      size_t pending_items = msg.user_data.size();
      for (auto item : msg.user_data) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: grid_ground
  {
    if (msg.grid_ground.size() == 0) {
      out << "grid_ground: []";
    } else {
      out << "grid_ground: [";
      size_t pending_items = msg.grid_ground.size();
      for (auto item : msg.grid_ground) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: grid_obstacles
  {
    if (msg.grid_obstacles.size() == 0) {
      out << "grid_obstacles: []";
    } else {
      out << "grid_obstacles: [";
      size_t pending_items = msg.grid_obstacles.size();
      for (auto item : msg.grid_obstacles) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: grid_empty_cells
  {
    if (msg.grid_empty_cells.size() == 0) {
      out << "grid_empty_cells: []";
    } else {
      out << "grid_empty_cells: [";
      size_t pending_items = msg.grid_empty_cells.size();
      for (auto item : msg.grid_empty_cells) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: grid_cell_size
  {
    out << "grid_cell_size: ";
    rosidl_generator_traits::value_to_yaml(msg.grid_cell_size, out);
    out << ", ";
  }

  // member: grid_view_point
  {
    out << "grid_view_point: ";
    to_flow_style_yaml(msg.grid_view_point, out);
    out << ", ";
  }

  // member: word_id_keys
  {
    if (msg.word_id_keys.size() == 0) {
      out << "word_id_keys: []";
    } else {
      out << "word_id_keys: [";
      size_t pending_items = msg.word_id_keys.size();
      for (auto item : msg.word_id_keys) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: word_id_values
  {
    if (msg.word_id_values.size() == 0) {
      out << "word_id_values: []";
    } else {
      out << "word_id_values: [";
      size_t pending_items = msg.word_id_values.size();
      for (auto item : msg.word_id_values) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: word_kpts
  {
    if (msg.word_kpts.size() == 0) {
      out << "word_kpts: []";
    } else {
      out << "word_kpts: [";
      size_t pending_items = msg.word_kpts.size();
      for (auto item : msg.word_kpts) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: word_pts
  {
    if (msg.word_pts.size() == 0) {
      out << "word_pts: []";
    } else {
      out << "word_pts: [";
      size_t pending_items = msg.word_pts.size();
      for (auto item : msg.word_pts) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: word_descriptors
  {
    if (msg.word_descriptors.size() == 0) {
      out << "word_descriptors: []";
    } else {
      out << "word_descriptors: [";
      size_t pending_items = msg.word_descriptors.size();
      for (auto item : msg.word_descriptors) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: global_descriptors
  {
    if (msg.global_descriptors.size() == 0) {
      out << "global_descriptors: []";
    } else {
      out << "global_descriptors: [";
      size_t pending_items = msg.global_descriptors.size();
      for (auto item : msg.global_descriptors) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: env_sensors
  {
    if (msg.env_sensors.size() == 0) {
      out << "env_sensors: []";
    } else {
      out << "env_sensors: [";
      size_t pending_items = msg.env_sensors.size();
      for (auto item : msg.env_sensors) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const NodeData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: map_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_id: ";
    rosidl_generator_traits::value_to_yaml(msg.map_id, out);
    out << "\n";
  }

  // member: weight
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "weight: ";
    rosidl_generator_traits::value_to_yaml(msg.weight, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp: ";
    rosidl_generator_traits::value_to_yaml(msg.stamp, out);
    out << "\n";
  }

  // member: label
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "label: ";
    rosidl_generator_traits::value_to_yaml(msg.label, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: ground_truth_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ground_truth_pose:\n";
    to_block_style_yaml(msg.ground_truth_pose, out, indentation + 2);
  }

  // member: gps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps:\n";
    to_block_style_yaml(msg.gps, out, indentation + 2);
  }

  // member: image
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.image.size() == 0) {
      out << "image: []\n";
    } else {
      out << "image:\n";
      for (auto item : msg.image) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: depth
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.depth.size() == 0) {
      out << "depth: []\n";
    } else {
      out << "depth:\n";
      for (auto item : msg.depth) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: fx
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fx.size() == 0) {
      out << "fx: []\n";
    } else {
      out << "fx:\n";
      for (auto item : msg.fx) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: fy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fy.size() == 0) {
      out << "fy: []\n";
    } else {
      out << "fy:\n";
      for (auto item : msg.fy) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: cx
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cx.size() == 0) {
      out << "cx: []\n";
    } else {
      out << "cx:\n";
      for (auto item : msg.cx) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: cy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cy.size() == 0) {
      out << "cy: []\n";
    } else {
      out << "cy:\n";
      for (auto item : msg.cy) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.width.size() == 0) {
      out << "width: []\n";
    } else {
      out << "width:\n";
      for (auto item : msg.width) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.height.size() == 0) {
      out << "height: []\n";
    } else {
      out << "height:\n";
      for (auto item : msg.height) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: baseline
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.baseline.size() == 0) {
      out << "baseline: []\n";
    } else {
      out << "baseline:\n";
      for (auto item : msg.baseline) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: local_transform
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.local_transform.size() == 0) {
      out << "local_transform: []\n";
    } else {
      out << "local_transform:\n";
      for (auto item : msg.local_transform) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: laser_scan
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.laser_scan.size() == 0) {
      out << "laser_scan: []\n";
    } else {
      out << "laser_scan:\n";
      for (auto item : msg.laser_scan) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: laser_scan_max_pts
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_scan_max_pts: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_scan_max_pts, out);
    out << "\n";
  }

  // member: laser_scan_max_range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_scan_max_range: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_scan_max_range, out);
    out << "\n";
  }

  // member: laser_scan_format
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_scan_format: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_scan_format, out);
    out << "\n";
  }

  // member: laser_scan_local_transform
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_scan_local_transform:\n";
    to_block_style_yaml(msg.laser_scan_local_transform, out, indentation + 2);
  }

  // member: user_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.user_data.size() == 0) {
      out << "user_data: []\n";
    } else {
      out << "user_data:\n";
      for (auto item : msg.user_data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: grid_ground
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grid_ground.size() == 0) {
      out << "grid_ground: []\n";
    } else {
      out << "grid_ground:\n";
      for (auto item : msg.grid_ground) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: grid_obstacles
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grid_obstacles.size() == 0) {
      out << "grid_obstacles: []\n";
    } else {
      out << "grid_obstacles:\n";
      for (auto item : msg.grid_obstacles) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: grid_empty_cells
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grid_empty_cells.size() == 0) {
      out << "grid_empty_cells: []\n";
    } else {
      out << "grid_empty_cells:\n";
      for (auto item : msg.grid_empty_cells) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: grid_cell_size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "grid_cell_size: ";
    rosidl_generator_traits::value_to_yaml(msg.grid_cell_size, out);
    out << "\n";
  }

  // member: grid_view_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "grid_view_point:\n";
    to_block_style_yaml(msg.grid_view_point, out, indentation + 2);
  }

  // member: word_id_keys
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.word_id_keys.size() == 0) {
      out << "word_id_keys: []\n";
    } else {
      out << "word_id_keys:\n";
      for (auto item : msg.word_id_keys) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: word_id_values
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.word_id_values.size() == 0) {
      out << "word_id_values: []\n";
    } else {
      out << "word_id_values:\n";
      for (auto item : msg.word_id_values) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: word_kpts
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.word_kpts.size() == 0) {
      out << "word_kpts: []\n";
    } else {
      out << "word_kpts:\n";
      for (auto item : msg.word_kpts) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: word_pts
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.word_pts.size() == 0) {
      out << "word_pts: []\n";
    } else {
      out << "word_pts:\n";
      for (auto item : msg.word_pts) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: word_descriptors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.word_descriptors.size() == 0) {
      out << "word_descriptors: []\n";
    } else {
      out << "word_descriptors:\n";
      for (auto item : msg.word_descriptors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: global_descriptors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.global_descriptors.size() == 0) {
      out << "global_descriptors: []\n";
    } else {
      out << "global_descriptors:\n";
      for (auto item : msg.global_descriptors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: env_sensors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.env_sensors.size() == 0) {
      out << "env_sensors: []\n";
    } else {
      out << "env_sensors:\n";
      for (auto item : msg.env_sensors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const NodeData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rtabmap_ros

namespace rosidl_generator_traits
{

[[deprecated("use rtabmap_ros::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rtabmap_ros::msg::NodeData & msg,
  std::ostream & out, size_t indentation = 0)
{
  rtabmap_ros::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rtabmap_ros::msg::to_yaml() instead")]]
inline std::string to_yaml(const rtabmap_ros::msg::NodeData & msg)
{
  return rtabmap_ros::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rtabmap_ros::msg::NodeData>()
{
  return "rtabmap_ros::msg::NodeData";
}

template<>
inline const char * name<rtabmap_ros::msg::NodeData>()
{
  return "rtabmap_ros/msg/NodeData";
}

template<>
struct has_fixed_size<rtabmap_ros::msg::NodeData>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rtabmap_ros::msg::NodeData>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rtabmap_ros::msg::NodeData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RTABMAP_ROS__MSG__DETAIL__NODE_DATA__TRAITS_HPP_
