// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rtabmap_ros:srv/GetNodeData.idl
// generated code does not contain a copyright notice

#ifndef RTABMAP_ROS__SRV__DETAIL__GET_NODE_DATA__STRUCT_HPP_
#define RTABMAP_ROS__SRV__DETAIL__GET_NODE_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rtabmap_ros__srv__GetNodeData_Request __attribute__((deprecated))
#else
# define DEPRECATED__rtabmap_ros__srv__GetNodeData_Request __declspec(deprecated)
#endif

namespace rtabmap_ros
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetNodeData_Request_
{
  using Type = GetNodeData_Request_<ContainerAllocator>;

  explicit GetNodeData_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->images = false;
      this->scan = false;
      this->grid = false;
      this->user_data = false;
    }
  }

  explicit GetNodeData_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->images = false;
      this->scan = false;
      this->grid = false;
      this->user_data = false;
    }
  }

  // field types and members
  using _ids_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _ids_type ids;
  using _images_type =
    bool;
  _images_type images;
  using _scan_type =
    bool;
  _scan_type scan;
  using _grid_type =
    bool;
  _grid_type grid;
  using _user_data_type =
    bool;
  _user_data_type user_data;

  // setters for named parameter idiom
  Type & set__ids(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->ids = _arg;
    return *this;
  }
  Type & set__images(
    const bool & _arg)
  {
    this->images = _arg;
    return *this;
  }
  Type & set__scan(
    const bool & _arg)
  {
    this->scan = _arg;
    return *this;
  }
  Type & set__grid(
    const bool & _arg)
  {
    this->grid = _arg;
    return *this;
  }
  Type & set__user_data(
    const bool & _arg)
  {
    this->user_data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rtabmap_ros__srv__GetNodeData_Request
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rtabmap_ros__srv__GetNodeData_Request
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetNodeData_Request_ & other) const
  {
    if (this->ids != other.ids) {
      return false;
    }
    if (this->images != other.images) {
      return false;
    }
    if (this->scan != other.scan) {
      return false;
    }
    if (this->grid != other.grid) {
      return false;
    }
    if (this->user_data != other.user_data) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetNodeData_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetNodeData_Request_

// alias to use template instance with default allocator
using GetNodeData_Request =
  rtabmap_ros::srv::GetNodeData_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rtabmap_ros


// Include directives for member types
// Member 'data'
#include "rtabmap_ros/msg/detail/node_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rtabmap_ros__srv__GetNodeData_Response __attribute__((deprecated))
#else
# define DEPRECATED__rtabmap_ros__srv__GetNodeData_Response __declspec(deprecated)
#endif

namespace rtabmap_ros
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetNodeData_Response_
{
  using Type = GetNodeData_Response_<ContainerAllocator>;

  explicit GetNodeData_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit GetNodeData_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _data_type =
    std::vector<rtabmap_ros::msg::NodeData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rtabmap_ros::msg::NodeData_<ContainerAllocator>>>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__data(
    const std::vector<rtabmap_ros::msg::NodeData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rtabmap_ros::msg::NodeData_<ContainerAllocator>>> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rtabmap_ros__srv__GetNodeData_Response
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rtabmap_ros__srv__GetNodeData_Response
    std::shared_ptr<rtabmap_ros::srv::GetNodeData_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetNodeData_Response_ & other) const
  {
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetNodeData_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetNodeData_Response_

// alias to use template instance with default allocator
using GetNodeData_Response =
  rtabmap_ros::srv::GetNodeData_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rtabmap_ros

namespace rtabmap_ros
{

namespace srv
{

struct GetNodeData
{
  using Request = rtabmap_ros::srv::GetNodeData_Request;
  using Response = rtabmap_ros::srv::GetNodeData_Response;
};

}  // namespace srv

}  // namespace rtabmap_ros

#endif  // RTABMAP_ROS__SRV__DETAIL__GET_NODE_DATA__STRUCT_HPP_
