// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rtabmap_ros:srv/GetNodesInRadius.idl
// generated code does not contain a copyright notice

#ifndef RTABMAP_ROS__SRV__DETAIL__GET_NODES_IN_RADIUS__TRAITS_HPP_
#define RTABMAP_ROS__SRV__DETAIL__GET_NODES_IN_RADIUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rtabmap_ros/srv/detail/get_nodes_in_radius__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rtabmap_ros
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetNodesInRadius_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: node_id
  {
    out << "node_id: ";
    rosidl_generator_traits::value_to_yaml(msg.node_id, out);
    out << ", ";
  }

  // member: x
  {
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << ", ";
  }

  // member: y
  {
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << ", ";
  }

  // member: z
  {
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
    out << ", ";
  }

  // member: radius
  {
    out << "radius: ";
    rosidl_generator_traits::value_to_yaml(msg.radius, out);
    out << ", ";
  }

  // member: k
  {
    out << "k: ";
    rosidl_generator_traits::value_to_yaml(msg.k, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetNodesInRadius_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: node_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "node_id: ";
    rosidl_generator_traits::value_to_yaml(msg.node_id, out);
    out << "\n";
  }

  // member: x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << "\n";
  }

  // member: y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << "\n";
  }

  // member: z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
    out << "\n";
  }

  // member: radius
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "radius: ";
    rosidl_generator_traits::value_to_yaml(msg.radius, out);
    out << "\n";
  }

  // member: k
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "k: ";
    rosidl_generator_traits::value_to_yaml(msg.k, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetNodesInRadius_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rtabmap_ros

namespace rosidl_generator_traits
{

[[deprecated("use rtabmap_ros::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rtabmap_ros::srv::GetNodesInRadius_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rtabmap_ros::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rtabmap_ros::srv::to_yaml() instead")]]
inline std::string to_yaml(const rtabmap_ros::srv::GetNodesInRadius_Request & msg)
{
  return rtabmap_ros::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rtabmap_ros::srv::GetNodesInRadius_Request>()
{
  return "rtabmap_ros::srv::GetNodesInRadius_Request";
}

template<>
inline const char * name<rtabmap_ros::srv::GetNodesInRadius_Request>()
{
  return "rtabmap_ros/srv/GetNodesInRadius_Request";
}

template<>
struct has_fixed_size<rtabmap_ros::srv::GetNodesInRadius_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rtabmap_ros::srv::GetNodesInRadius_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rtabmap_ros::srv::GetNodesInRadius_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'poses'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace rtabmap_ros
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetNodesInRadius_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: ids
  {
    if (msg.ids.size() == 0) {
      out << "ids: []";
    } else {
      out << "ids: [";
      size_t pending_items = msg.ids.size();
      for (auto item : msg.ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: poses
  {
    if (msg.poses.size() == 0) {
      out << "poses: []";
    } else {
      out << "poses: [";
      size_t pending_items = msg.poses.size();
      for (auto item : msg.poses) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: dists_sqr
  {
    if (msg.dists_sqr.size() == 0) {
      out << "dists_sqr: []";
    } else {
      out << "dists_sqr: [";
      size_t pending_items = msg.dists_sqr.size();
      for (auto item : msg.dists_sqr) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetNodesInRadius_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids.size() == 0) {
      out << "ids: []\n";
    } else {
      out << "ids:\n";
      for (auto item : msg.ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: poses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.poses.size() == 0) {
      out << "poses: []\n";
    } else {
      out << "poses:\n";
      for (auto item : msg.poses) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: dists_sqr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.dists_sqr.size() == 0) {
      out << "dists_sqr: []\n";
    } else {
      out << "dists_sqr:\n";
      for (auto item : msg.dists_sqr) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetNodesInRadius_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rtabmap_ros

namespace rosidl_generator_traits
{

[[deprecated("use rtabmap_ros::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rtabmap_ros::srv::GetNodesInRadius_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rtabmap_ros::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rtabmap_ros::srv::to_yaml() instead")]]
inline std::string to_yaml(const rtabmap_ros::srv::GetNodesInRadius_Response & msg)
{
  return rtabmap_ros::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rtabmap_ros::srv::GetNodesInRadius_Response>()
{
  return "rtabmap_ros::srv::GetNodesInRadius_Response";
}

template<>
inline const char * name<rtabmap_ros::srv::GetNodesInRadius_Response>()
{
  return "rtabmap_ros/srv/GetNodesInRadius_Response";
}

template<>
struct has_fixed_size<rtabmap_ros::srv::GetNodesInRadius_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rtabmap_ros::srv::GetNodesInRadius_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rtabmap_ros::srv::GetNodesInRadius_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rtabmap_ros::srv::GetNodesInRadius>()
{
  return "rtabmap_ros::srv::GetNodesInRadius";
}

template<>
inline const char * name<rtabmap_ros::srv::GetNodesInRadius>()
{
  return "rtabmap_ros/srv/GetNodesInRadius";
}

template<>
struct has_fixed_size<rtabmap_ros::srv::GetNodesInRadius>
  : std::integral_constant<
    bool,
    has_fixed_size<rtabmap_ros::srv::GetNodesInRadius_Request>::value &&
    has_fixed_size<rtabmap_ros::srv::GetNodesInRadius_Response>::value
  >
{
};

template<>
struct has_bounded_size<rtabmap_ros::srv::GetNodesInRadius>
  : std::integral_constant<
    bool,
    has_bounded_size<rtabmap_ros::srv::GetNodesInRadius_Request>::value &&
    has_bounded_size<rtabmap_ros::srv::GetNodesInRadius_Response>::value
  >
{
};

template<>
struct is_service<rtabmap_ros::srv::GetNodesInRadius>
  : std::true_type
{
};

template<>
struct is_service_request<rtabmap_ros::srv::GetNodesInRadius_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rtabmap_ros::srv::GetNodesInRadius_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RTABMAP_ROS__SRV__DETAIL__GET_NODES_IN_RADIUS__TRAITS_HPP_
