// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rtabmap_ros:srv/ResetPose.idl
// generated code does not contain a copyright notice

#ifndef RTABMAP_ROS__SRV__DETAIL__RESET_POSE__TRAITS_HPP_
#define RTABMAP_ROS__SRV__DETAIL__RESET_POSE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rtabmap_ros/srv/detail/reset_pose__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rtabmap_ros
{

namespace srv
{

inline void to_flow_style_yaml(
  const ResetPose_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: x
  {
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << ", ";
  }

  // member: y
  {
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << ", ";
  }

  // member: z
  {
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
    out << ", ";
  }

  // member: roll
  {
    out << "roll: ";
    rosidl_generator_traits::value_to_yaml(msg.roll, out);
    out << ", ";
  }

  // member: pitch
  {
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << ", ";
  }

  // member: yaw
  {
    out << "yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ResetPose_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << "\n";
  }

  // member: y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << "\n";
  }

  // member: z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
    out << "\n";
  }

  // member: roll
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll: ";
    rosidl_generator_traits::value_to_yaml(msg.roll, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: yaw
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ResetPose_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rtabmap_ros

namespace rosidl_generator_traits
{

[[deprecated("use rtabmap_ros::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rtabmap_ros::srv::ResetPose_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rtabmap_ros::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rtabmap_ros::srv::to_yaml() instead")]]
inline std::string to_yaml(const rtabmap_ros::srv::ResetPose_Request & msg)
{
  return rtabmap_ros::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rtabmap_ros::srv::ResetPose_Request>()
{
  return "rtabmap_ros::srv::ResetPose_Request";
}

template<>
inline const char * name<rtabmap_ros::srv::ResetPose_Request>()
{
  return "rtabmap_ros/srv/ResetPose_Request";
}

template<>
struct has_fixed_size<rtabmap_ros::srv::ResetPose_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rtabmap_ros::srv::ResetPose_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rtabmap_ros::srv::ResetPose_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rtabmap_ros
{

namespace srv
{

inline void to_flow_style_yaml(
  const ResetPose_Response & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ResetPose_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ResetPose_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rtabmap_ros

namespace rosidl_generator_traits
{

[[deprecated("use rtabmap_ros::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rtabmap_ros::srv::ResetPose_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rtabmap_ros::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rtabmap_ros::srv::to_yaml() instead")]]
inline std::string to_yaml(const rtabmap_ros::srv::ResetPose_Response & msg)
{
  return rtabmap_ros::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rtabmap_ros::srv::ResetPose_Response>()
{
  return "rtabmap_ros::srv::ResetPose_Response";
}

template<>
inline const char * name<rtabmap_ros::srv::ResetPose_Response>()
{
  return "rtabmap_ros/srv/ResetPose_Response";
}

template<>
struct has_fixed_size<rtabmap_ros::srv::ResetPose_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rtabmap_ros::srv::ResetPose_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rtabmap_ros::srv::ResetPose_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rtabmap_ros::srv::ResetPose>()
{
  return "rtabmap_ros::srv::ResetPose";
}

template<>
inline const char * name<rtabmap_ros::srv::ResetPose>()
{
  return "rtabmap_ros/srv/ResetPose";
}

template<>
struct has_fixed_size<rtabmap_ros::srv::ResetPose>
  : std::integral_constant<
    bool,
    has_fixed_size<rtabmap_ros::srv::ResetPose_Request>::value &&
    has_fixed_size<rtabmap_ros::srv::ResetPose_Response>::value
  >
{
};

template<>
struct has_bounded_size<rtabmap_ros::srv::ResetPose>
  : std::integral_constant<
    bool,
    has_bounded_size<rtabmap_ros::srv::ResetPose_Request>::value &&
    has_bounded_size<rtabmap_ros::srv::ResetPose_Response>::value
  >
{
};

template<>
struct is_service<rtabmap_ros::srv::ResetPose>
  : std::true_type
{
};

template<>
struct is_service_request<rtabmap_ros::srv::ResetPose_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rtabmap_ros::srv::ResetPose_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RTABMAP_ROS__SRV__DETAIL__RESET_POSE__TRAITS_HPP_
