// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rtabmap_ros:srv/SetLabel.idl
// generated code does not contain a copyright notice

#ifndef RTABMAP_ROS__SRV__DETAIL__SET_LABEL__STRUCT_HPP_
#define RTABMAP_ROS__SRV__DETAIL__SET_LABEL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rtabmap_ros__srv__SetLabel_Request __attribute__((deprecated))
#else
# define DEPRECATED__rtabmap_ros__srv__SetLabel_Request __declspec(deprecated)
#endif

namespace rtabmap_ros
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetLabel_Request_
{
  using Type = SetLabel_Request_<ContainerAllocator>;

  explicit SetLabel_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->node_id = 0l;
      this->node_label = "";
    }
  }

  explicit SetLabel_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : node_label(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->node_id = 0l;
      this->node_label = "";
    }
  }

  // field types and members
  using _node_id_type =
    int32_t;
  _node_id_type node_id;
  using _node_label_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _node_label_type node_label;

  // setters for named parameter idiom
  Type & set__node_id(
    const int32_t & _arg)
  {
    this->node_id = _arg;
    return *this;
  }
  Type & set__node_label(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->node_label = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rtabmap_ros__srv__SetLabel_Request
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rtabmap_ros__srv__SetLabel_Request
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetLabel_Request_ & other) const
  {
    if (this->node_id != other.node_id) {
      return false;
    }
    if (this->node_label != other.node_label) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetLabel_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetLabel_Request_

// alias to use template instance with default allocator
using SetLabel_Request =
  rtabmap_ros::srv::SetLabel_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rtabmap_ros


#ifndef _WIN32
# define DEPRECATED__rtabmap_ros__srv__SetLabel_Response __attribute__((deprecated))
#else
# define DEPRECATED__rtabmap_ros__srv__SetLabel_Response __declspec(deprecated)
#endif

namespace rtabmap_ros
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetLabel_Response_
{
  using Type = SetLabel_Response_<ContainerAllocator>;

  explicit SetLabel_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit SetLabel_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rtabmap_ros__srv__SetLabel_Response
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rtabmap_ros__srv__SetLabel_Response
    std::shared_ptr<rtabmap_ros::srv::SetLabel_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetLabel_Response_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetLabel_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetLabel_Response_

// alias to use template instance with default allocator
using SetLabel_Response =
  rtabmap_ros::srv::SetLabel_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rtabmap_ros

namespace rtabmap_ros
{

namespace srv
{

struct SetLabel
{
  using Request = rtabmap_ros::srv::SetLabel_Request;
  using Response = rtabmap_ros::srv::SetLabel_Response;
};

}  // namespace srv

}  // namespace rtabmap_ros

#endif  // RTABMAP_ROS__SRV__DETAIL__SET_LABEL__STRUCT_HPP_
